unit Unit1;
{$mode objfpc}{$H+}
interface
uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  ExtCtrls, Unix, StdCtrls, Grids,TAChartUtils , spi_mcp3208;
type
  { TForm1 }
    TForm1 = class(TForm)
    AutoScale: TGroupBox;
    Redraw: TButton;
    ChartSave: TButton;
    Clear:     TButton;
    DataSave:  TButton;
    Start:     TButton;
    Stop:      TButton;
    EXT:       TButton;
    ComboCount:    TComboBox;
    ComboSampling: TComboBox;
    ChartConfig: TGroupBox;
    GroupBox1:   TGroupBox;
    ChartSaveGB: TGroupBox;
    Scroll:  TEdit;
    YMax:    TEdit;
    YMin:    TEdit;
    XSize:   TEdit;
    YSize:   TEdit;
    TitleBox:TEdit;
    Title_Memo: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TotalTime: TLabel;
    LCH1: TPanel;
    LCH2: TPanel;
    LCH3: TPanel;
    LCH4: TPanel;
    LCH5: TPanel;
    LCH6: TPanel;
    LCH7: TPanel;
    LCH8: TPanel;
    RadioGroup1: TRadioGroup;
    RadioPNG:    TRadioButton;
    RadioJPG:    TRadioButton;
    RB_Repeat:   TRadioButton;
    RB_Single:   TRadioButton;
    SaveDialog1: TSaveDialog;
    StringGrid1: TStringGrid;
    chkYMax:     TCheckBox;
    chkYMin:     TCheckBox;
    chkXScroll:  TCheckBox;
    chkTimeAxis: TCheckBox;

    procedure ChartSaveClick(Sender: TObject);
    procedure chkTimeAxisChange(Sender: TObject);
    procedure chkXScrollChange(Sender: TObject);
    procedure chkYMaxChange(Sender: TObject);
    procedure chkYMinChange(Sender: TObject);
    procedure ClearClick(Sender: TObject);
    procedure ComboCountChange(Sender: TObject);
    procedure ComboSamplingChange(Sender: TObject);
    procedure EXTClick(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DataSaveClick(Sender: TObject);
    procedure RedrawClick(Sender: TObject);
    procedure ScrollKeyPress(Sender: TObject; var Key: char);
    procedure StartClick(Sender: TObject);
    procedure StopClick(Sender: TObject);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure XSizeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure YMaxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure YMinKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure YSizeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

private
    { private declarations }
public
    { public declarations }
    procedure ConvertSamplingtime; // サンプリング時間をtSplclkに変換する。
    procedure Fastmeasure;         // 100us  - 20ms の測定
    procedure Slowmeasure;         // 50ms  - 1sec  の測定
    procedure SetCoefOffset;       // Coef,Offset   の読込みと設定
    procedure Postprocess;         // 測定後の描画処理
    function  TimeToStr(t:TDatetime):String;// TDatetimeをStringに変換

var
    sCoef:   Array[1..8] of Single;//ADC 入力係数
    sOffset: Array[1..8] of Single;//ADC オフセット  Output=ADC_value x coef + offset
    wMeasData:Array of Array of WORD;
    
    dwMaxCount :    DWORD;      // 最大測定カウント数
    dwSamplingcount:DWORD;      // 測定カウント数
    dwDisplaypoint: DWORD;      // 表示カウント数
    bSTOP:           BYTE;      // Stopボタンによる停止用変数
    bRunning:        BYTE;      // 停止中 0, 動作中 1
    wScrollPoint:    WORD;      // チャートスクロールポイント数
    
    tStarttime: TDatetime;      // 開始時間
    tEndtime:   TDatetime;      // 終了時間
    tProctime:  TDatetime;      // 処理時間
    tSplclk:    TDatetime;      // サンプリングクロック時間
    tTime:      TDatetime;      // トータル測定時間
    
    tSec        :TDatetime;     // 1 秒
    tMsec       :TDatetime;     // 1 ミリ秒
    tUsec       :TDatetime;     // 1 マイクロ秒
    
    Analog:TSPI;                  // ADCモジュール
end;

var
    Form1: TForm1;
implementation
//他のUnitを追加する時は循環参照を避けるため implementationの次に記述する
uses  Unit2,Unit3;

{$R *.lfm}

{ TForm1 }
//*************************************************
//  メインフォーム生成時の初期設定
//*************************************************
procedure TForm1.FormCreate(Sender: TObject);
begin
    Analog:=TSPI.Create; // ADC用SPIの生成・初期化、名前をAnalogにする。

    // 時間定義
    tSec :=1/24/60/60;      // 秒
    tMsec:=tSec/1000;       // ミリ秒
    tUsec:=tMsec/1000;      // マイクロ秒

    ComboSamplingChange(Self);// サンプリング数とクロック設定
    Form2.ChartSet;           // Chartの凡例設定    
    SetCoefOffset;            // 係数、オフセット設定
    Form1.XSize.Text:=IntToStr(Form2.Width);
    Form1.YSize.Text:=IntToStr(Form2.Height);
    wScrollPoint:=StrToInt(Scroll.Text); //水平スクロールのポイント数
end;

//*************************************************
// TextFileSaveをクリックして数値データを保存する処理
//*************************************************
procedure TForm1.DataSaveClick(Sender: TObject);
begin
//   SaveDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
   SaveDialog1.InitialDir:='./';
   SaveDialog1.DefaultExt:='txt';
   if SaveDialog1.Execute then
         begin
             Form3.Memo1.Lines.SaveToFile(SaveDialog1.FileName);
         end;
end;

//******************************************************
// 再描画の処理
//******************************************************
procedure TForm1.RedrawClick(Sender: TObject);
var
  i:DWORD;
  ch:BYTE;
  val:Single;
begin
  if(bRunning > 0) then
     begin
        ShowMessage('Stopで停止させてから再描画してください。');
        Exit;
     end;

    Form2.ChartClear;
    Form2.SetFocus;
    Form2.Chart1.Extent.UseXmin:=true;
    Form2.Chart1.Extent.XMin:=0;
    
    Application.ProcessMessages;
    bStop:=0;
    i:=0;
    repeat   // calculate and addpoint to graph
       begin
           for ch:=0 to 7 do
               begin
                  val:=Single(wMeasData[i][ch])* (analog.ref_voltage)*sCoef[ch+1]+sOffset[ch+1];

                  if(chkTimeAxis.Checked=True)then
                         Form2.LSeries[ch+1].AddXY(tSplclk*i,val)
                     else
                         Form2.LSeries[ch+1].AddXY(i,val);
               end;
           i:=i+1;
       end;
    until (i>= dwSamplingCount) OR (bStop=1);
end;

//************************************************************
// X軸スクロールのポイント数入力、Enterを押したら入力処理する。
//************************************************************
procedure TForm1.ScrollKeyPress(Sender: TObject; var Key: char);
begin
   if key =#13 then
       begin
          try //スクロールポイントの読込み
             wScrollPoint:=StrToInt(Scroll.Text);
          except
              on E: Exception do
              begin
                  ShowMessage('スクロール設定は数字で入力してくだしさい。');
                  Scroll.Text:='100';
                  wScrollPoint:=100;
              end;
        end;
    end;
end;

//******************************************************
// 描画したグラフチャートを png,jpg変換して保存する処理
//******************************************************
procedure TForm1.ChartSaveClick(Sender: TObject);
var
     filename:String;
          str:String;
            r:TRect;
          bmp:TBitmap;
          jpg:TJpegImage;
          png:TPortableNetworkGraphic;
          x,y:WORD;
begin
//  SaveDialog1.InitialDir:=ExtractFilePath(Application.ExeName);
    SaveDialog1.InitialDir:='./';

    if(RadioPNG.Checked) then
        begin
           SaveDialog1.DefaultExt:='png';
           SaveDialog1.Filter:='PngFile|*.png';
        end;
    if(RadioJPG.Checked) then
        begin
            SaveDialog1.DefaultExt:='jpg';
            SaveDialog1.Filter:='JpegFile|*.jpg';
        end;

    if SaveDialog1.Execute then // Saveボタンをクリックしたときの処理
        begin
           str:=SaveDialog1.Filename;
           filename:=Trim(ExtractFileName(str));//パス名を除いたファイル名
           if filename='' then Exit; //ファイル名の指定が無ければ 抜ける。
     
           Form2.SetFocus;             // Chart画面を最前面に設定
           Application.ProcessMessages;// 実行、他のフォームが重なって欠落することの対策

           x:=StrToInt(XSize.Text);
           y:=StrToInt(YSize.Text);

// Bitmapから PNG,JPGに画像に変換してファイル保存する。

           bmp:=TBitmap.Create;        // bmp 生成
           bmp.Width:=x;               // bmp サイズ幅設定
           bmp.Height:=y;              // bmp サイズ高さ設定
           r:=Rect(0,0,x,y);           // コピーサイズ設定
           bmp.Canvas.CopyRect(r,Form2.Canvas,r);// Form2のChart⇒bmpにコピー

           if(RadioPNG.Checked) then // png フォーマット選択の処理
               begin
                  png:=TPortableNetworkGraphic.Create; // png 生成
                  png.Assign(bmp);    //bmpをpngに変換
                  str:=ChangeFileExt(str,'.png');//ファイル拡張子を .pngにする
                  png.SaveToFile(str);//png ファイル保存
                  png.Free;           //廃棄
               end;

           if(RadioJPG.Checked) then // jpg フォーマット選択の処理
               begin
                  jpg:=TJpegImage.Create; // jpg 生成
                  jpg.Assign(bmp);     //bmpをjpgに変換
                  str:=ChangeFileExt(str,'.jpg');//ファイル拡張子を .jpgにする
                  jpg.SaveToFile(str); //jpg ファイル保存
                  jpg.Free;            //廃棄 
               end;
     end;
end;

//*************************************************
//
//*************************************************
procedure TForm1.chkTimeAxisChange(Sender: TObject);
begin
  Form2.TimeAxisSet(chkTimeAxis.Checked);
end;

//*************************************************
//
//*************************************************
procedure TForm1.chkXScrollChange(Sender: TObject);
begin
    Form2.Chart1.Extent.UseXmin:=not chkXScroll.Checked;
end;

//*************************************************
//
//*************************************************
procedure TForm1.chkYMaxChange(Sender: TObject);
begin
      Form2.Chart1.Extent.UseYmax:=not chkYMax.Checked;
end;

//*************************************************
//
//*************************************************
procedure TForm1.chkYMinChange(Sender: TObject);
begin
      Form2.Chart1.Extent.UseYmin:=not chkYmin.Checked;
end;

//*************************************************
// Form Close処理
//*************************************************
procedure TForm1.FormClose(Sender: TObject);
begin
    Analog.Free;
    Form2.Close;
    Form3.Close;
end;
//*************************************************
//
//*************************************************
procedure TForm1.ComboCountChange(Sender: TObject);
begin
    ComboSamplingChange(Self);
end;
//*************************************************
// ComboBox　サンプリングクロックをtsplclkに変換する。
//*************************************************
procedure TForm1.ConvertSamplingtime;
begin
    case ComboSampling.ItemIndex of
     0: begin  tSplclk:=tMsec;       end; //1ms
     1: begin  tSplclk:=tMsec*2;     end;
     2: begin  tSplclk:=tMsec*5;     end;
     3: begin  tSplclk:=tMsec*10;    end;// 10ms
     4: begin  tSplclk:=tMsec*20;    end;
     5: begin  tSplclk:=tMsec*50;    end;
     6: begin  tSplclk:=tMsec*100;   end;// 100ms
     7: begin  tSplclk:=tMsec*200;   end;
     8: begin  tSplclk:=tMsec*500;   end;
     9: begin  tSplclk:=tSec;        end;// 1sec
    10: begin  tSplclk:=tSec*2;      end;
    11: begin  tSplclk:=tSec*5       end;
    12: begin  tSplclk:=tSec*10;     end;// 10sec

     else
      ComboSampling.ItemIndex:=6;  // other case , default 100ms
      tSplclk:=tMsec;
    end;
end;

//*************************************************
//  サンプリング数の設定、サンプリングクロック設定
//*************************************************
procedure TForm1.ComboSamplingChange(Sender: TObject);
begin
 dwMaxCount:=StrToInt(ComboCount.Items[ComboCount.ItemIndex]);

   SetLength(wMeasData,dwMaxCount+1,8); //受信バッファサイズを再設定
   ConvertSamplingtime;
   tTime:=dwMaxCount*tSplclk;
   TotalTime.Caption:=TimeToStr(tTime);
end;



//*************************************************
// Start 処理
//*************************************************
procedure TForm1.StartClick(Sender: TObject);
begin

    bSTOP:=0;
    bRunning:=1;
    SetCoefOffset; // 係数オフセット読込み
    Form2.ChartSet;//Chart凡例のテキスト及び色設定


    try //スクロールポイントの読込み
       wScrollPoint:=StrToInt(Scroll.Text);
    except
       on E: Exception do
       begin
         ShowMessage('スクロール設定は数字で入力してくだしさい。');
         Scroll.Text:='100';
         wScrollPoint:=100;
       end;
    end;

    ComboSamplingChange(Self);
    Form2.ChartClear;
    Form2.SetFocus;

    dwMaxCount:=StrToInt(ComboCount.Items[ComboCount.ItemIndex]);


    // UseXmaxをfalseにすると常に右端に最新データを追加するので見やすい。
    Form2.Chart1.Extent.XMin:=0;
    if(chkTimeAxis.Checked=True)then
                Form2.Chart1.Extent.XMax:=tSplclk*dwMaxCount
            else
                Form2.Chart1.Extent.XMax:=dwMaxCount;
    Form2.Chart1.Extent.UseXmin:=true;
    Form2.Chart1.Extent.UseYmax:=not chkYMax.Checked;
    Form2.Chart1.Extent.UseYmin:=not chkYMin.Checked;
    
    Form2.Chart1.Extent.YMax:=StrToFloat(YMax.Text);
    Form2.Chart1.Extent.YMin:=StrToFloat(YMin.Text);
    
    if( Form1.Title_Memo.GetTextLen = 0) then
       begin
           Form2.Chart1.Title.Visible:=False;
       end
     else
       begin
           Form2.Chart1.Title.Text.Clear;
           Form2.Chart1.Title.Text.Assign(Form1.Title_Memo.Lines);
           Form2.Chart1.Title.Visible:=True;
       end;

    repeat
       begin   // repeat (single) measurement
           Form2.ChartClear;
           Form3.Memo1.Lines.Clear;
           Application.ProcessMessages;
           Form3.Memo1.Lines.Add('Process start');

           if  tSplclk > ( 30*tMsec) then
                begin      // sampling : 50ms - 60sec
                   Slowmeasure;
                end
           else
                begin     // sampling :  1ms - 20ms
                   Fastmeasure;
                end;

            tProctime:=tEndtime-tStarttime;
            Form3.Memo1.Lines.Add('Process time is '+FormatDateTime('h:mm:ss.zz',tProctime));

            Application.ProcessMessages;

            if(RB_Single.Checked = True)then
                 begin
                    bSTOP:=1;
                 end;
       end;
    until (bSTOP=1);

bRunning:=0;

end;

//*************************************************
//  50ms～60secサンプリングの計測処理
//*************************************************
procedure TForm1.Slowmeasure;   //  Samplingtime 50ms - 60sec
var
      tNext:TDatetime;
      tNt  :TDatetime;
      ch:BYTE;
      val:Single;
begin
        dwDisplaypoint:=0;
        Analog.Read(wMeasData[0]);//8chまとめて読込み,ダミー読み

        dwSamplingCount:=0;
        tNt:=Now;
        tStarttime:=TNt;
        Form2.Chart1.Extent.UseXmax:=false;
 
        repeat
               begin
                  
                Analog.Read(wMeasData[dwSamplingCount]);//8chまとめて読込み

                   for ch:=0 to 7 do
                      begin
                       val:=Single(wMeasData[dwSamplingCount][ch])* (analog.ref_voltage)*sCoef[ch+1]+sOffset[ch+1];

                      
                      // グラフポイントがスクロール設定値より増えたら 古いポイントを削除する。
                      while (Form2.LSeries[ch+1].Count > wScrollPoint) and (chkXScroll.Checked=true) do
                         begin
                            Form2.Chart1.Extent.UseXmin:=false;
                            Form2.LSeries[ch+1].Delete(0);
                         end;

                       if(chkTimeAxis.Checked=True)then
                             Form2.LSeries[ch+1].AddXY(tSplclk*dwSamplingCount,val)
                         else
                             Form2.LSeries[ch+1].AddXY(dwSamplingCount,val);
                      end;

                 dwSamplingCount:=dwSamplingCount+1;
                 tNext:= tSplclk*dwSamplingCount+tStarttime;
                 Application.ProcessMessages;
                 repeat
                          begin
                            tNt:=Now;
                          end;
                   until(tNt >= tNext);// wait for next sampling time
               end;
        until (dwSamplingCount>= dwMaxCount)OR (bStop=1); //繰返しループの中止条件
        tEndtime:=tNt;
        Postprocess;
        
end;

//*************************************************
//  1ms～50msサンプリングの計測処理
//*************************************************
procedure TForm1.Fastmeasure;   //  Samplingtime 1ms - 20ms
var
      tNext:TDatetime;
      tNt  :TDatetime;
      ch:BYTE;
      val:Single;
      i:DWORD;

begin

        Form2.Chart1.Extent.UseXmax:=true;
        dwDisplaypoint:=0;
        
        fpsystem('local_irq_disable');//割込み禁止
        fpsystem('local_fiq_disable');
        
        dwSamplingCount:=0;
        tNt:=Now;
        tStarttime:=TNt;
        repeat
               begin
                Analog.Read(wMeasData[dwSamplingCount]);//8chまとめて読込み
                dwSamplingCount:=dwSamplingCount+1;
                tNext:= tSplclk*dwSamplingCount+tStarttime;
                  repeat
                          begin
                            tNt:=Now;
                          end;
                   until(tNt >= tNext);// wait for next sampling time
               end;
        until (dwSamplingCount>= dwMaxCount)OR (bStop=1); //繰返しループの中止条件
        
        fpsystem('local_fiq_enable');//割込み許可
        fpsystem('local_irq_enable');

        i:=0;
        repeat   // calculate and addpoint to graph
           begin
               for ch:=0 to 7 do
                   begin
                      val:=Single(wMeasData[i][ch])* (analog.ref_voltage)*sCoef[ch+1]+sOffset[ch+1];

                      if(chkTimeAxis.Checked=True)then
                             Form2.LSeries[ch+1].AddXY(tSplclk*i,val)
                         else
                             Form2.LSeries[ch+1].AddXY(i,val);
                   end;
               i:=i+1;
           end;
        until (i>= dwSamplingCount) OR (bStop=1);

        tEndtime:=tNt;
        
        //高速読込みで Repeat繰返しが設定されている時は Text表示は最終回のみにする。
       if(RB_Single.Checked)then
            Postprocess;
        
end;

//*************************************************
// Text 表示部の実装
//*************************************************
procedure TForm1.Postprocess;   //  Postprocess of Fast & Quick measure
var
      i:DWORD;
      tCnt:TDateTime;
      str:AnsiString;
      sp:String;
      ss:String;
      ch:BYTE;
      val:Single;
begin
       sp:='         ';
      str:='    No.  ';
      ss:=StringGrid1.Cells[1,1]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,2]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,3]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,4]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,5]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,6]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,7]+sp; SetLength(ss,9); str:=str+ss;
      ss:=StringGrid1.Cells[1,8]+sp; SetLength(ss,9); str:=str+ss;
      str:=str+' Time'+#13#10;

      tCnt:=0.0;
      i:=0;
     repeat
          begin
             str:=str+Format('%6d  ',[i]);
             for ch:=0 to 7 do
                begin
                  val:=Single(wMeasData[i][ch])* (analog.ref_voltage)*sCoef[ch+1]+sOffset[ch+1];
                  str:=str+FormatFloat('0.0000V  ',val);
                end;
                  str:=str+'  ' +TimeToStr(tCnt)+#13#10;
                  tCnt:=tCnt+tSplclk; // elapsed time
             //     Application.ProcessMessages;
             i:=i+1;
          end;
     until (i>=dwSamplingCount);

     Form3.Memo1.Lines.Text:=str;
end;

//*************************************************
// Stopボタン処理
//*************************************************
procedure TForm1.StopClick(Sender: TObject);
begin
     bSTOP:=1;
     RB_Single.Checked:=True;
end;

//*************************************************
// Chart設定表を変更されたときの処理
//*************************************************
procedure TForm1.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if( Key = 13) then
      begin
       SetCoefOffset;
       Form2.ChartSet;//Chart凡例のテキスト及び色設定
      end;
end;

//*************************************************
// 係数、オフセット読込み
//*************************************************
procedure TForm1.SetCoefOffset;
var
    i:Integer;
    str:String;
begin
    for i:=1 to 8 do   // 係数、オフセット読込み
        begin
              str:=Trim(StringGrid1.Cells[2,i]);
              if (str='') OR (str='.') OR (str='-')then str:='0.0';
              sCoef[i]:=StrToFloat(str);

              str:=Trim(StringGrid1.Cells[3,i]);
              if (str='') OR (str='.')OR (str='-') then str:='0.0';
              sOffset[i]:=StrToFloat(Str);
        end;
end;

//*************************************************
// X Size 設定
//*************************************************
procedure TForm1.XSizeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if(Key = 13) then
     begin
       Key:=0;
       Form2.Width:=StrToInt(XSize.Text);
     end;
end;

//*************************************************
// Y Max 設定
//*************************************************
procedure TForm1.YMaxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if( Key = 13) then
      begin
        Form2.Chart1.Extent.YMax:=StrToFloat(YMax.Text);
      end;
end;

//*************************************************
// Y Min 設定
//*************************************************
procedure TForm1.YMinKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if( Key = 13) then
      begin
        Form2.Chart1.Extent.YMin:=StrToFloat(YMin.Text);
      end;
end;

//*************************************************
// Y Size 設定
//*************************************************
procedure TForm1.YSizeKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   if(Key = 13) then
     begin
        Key:=0;
        Form2.Height:=StrToInt(YSize.Text);
     end;

end;

//*************************************************
// Exitボタンの終了処理
//*************************************************
procedure TForm1.EXTClick(Sender: TObject);
begin
     bSTOP:=1;
     Analog.Free;
     Form3.Close;
     Form2.Close;
     Application.Terminate;
     
end;

//*************************************************
// Clearボタンの処理、グラフ描画とデータを消去する。
//*************************************************
procedure TForm1.ClearClick(Sender: TObject);
begin
  Form2.ChartClear;
  Form3.Memo1.Lines.Clear;
end;

//*************************************************
// TDatetime から String への文字変換
//*************************************************
function TForm1.TimeToStr(t:TDatetime) : String;
  var
    dbl:Double;
begin
       dbl:=Double(t)/Double(tMsec);
         if dbl <  1000.0 then
              begin                  //  < 1sec
                    Result:=FormatFloat('#,##0ms',(dbl));
              end
         else if dbl < 60000.0 then  //  < 60sec
                begin
                    Result:=FormatFloat('#,##0.0s',(dbl/1000.0));
                 end
         else
              begin                 //   > 60sec
                    Result:=FormatDatetime('h:nn:ss',t);
               end;
end;

end.
