unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, TAGraph,TATools, TASources,TASeries,TAChartUtils;
  
type

  { TForm2 }

  TForm2 = class(TForm)
    CH1: TCheckBox;
    CH2: TCheckBox;
    CH3: TCheckBox;
    CH4: TCheckBox;
    CH5: TCheckBox;
    CH6: TCheckBox;
    CH7: TCheckBox;
    CH8: TCheckBox;
    Chart1: TChart;
    ChartToolset1: TChartToolset;
    ChartToolset1ZoomDragTool1: TZoomDragTool;
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    LCH1: TPanel;
    LCH2: TPanel;
    LCH3: TPanel;
    LCH4: TPanel;
    LCH5: TPanel;
    LCH6: TPanel;
    LCH7: TPanel;
    LCH8: TPanel;
    Panel1: TPanel;
    
    procedure CH1Change(Sender: TObject);
    procedure CH2Change(Sender: TObject);
    procedure CH3Change(Sender: TObject);
    procedure CH4Change(Sender: TObject);
    procedure CH5Change(Sender: TObject);
    procedure CH6Change(Sender: TObject);
    procedure CH7Change(Sender: TObject);
    procedure CH8Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }

    procedure ChartClear;
    procedure ChartSet;
    procedure TimeAxisSet(b:Boolean);
  var
    LSeries : Array[1..8]  of TLineSeries; //Chart Line Series for 8ch
    ChColor:Array[1..8] of TColor;
  
  end; 

var
  Form2: TForm2; 

implementation

//他のUnitを追加する時は循環参照を避けるため implementationの次に記述する
uses Unit1; 

{$R *.lfm}
//*************************************************
// Chartの初期化
//*************************************************
procedure TForm2.FormCreate(Sender: TObject);
   var
      i:Integer;
begin
      for i:=1 to 8 do   // Create TLineSeries on Chart
            begin
                 LSeries[i]:=TLineSeries.Create(Self);
                 Chart1.AddSeries(LSeries[i]);
                 LSeries[i].LinePen.Width := 2;
                 LSeries[i].Active := True;
            end;
end;
//*************************************************
//  X軸の時間軸表示 設定・解除
//*************************************************
procedure TForm2.TimeAxisSet(b:Boolean);
begin
    if(Form1.tTime < 10*Form1.tSec)then
       b:=False;  // 10秒以下の計測では 時間軸表示を行なわない。

    if(b) then
       begin
           Chart1.BottomAxis.Marks.Source:= DateTimeIntervalChartSource1;// Time axis
           Chart1.BottomAxis.Marks.Style := TSeriesMarksStyle(smsLabel);
           Chart1.BottomAxis.Marks.Format:= '%2:s';              // Bottom label format
           Chart1.BottomAxis.Marks.LabelFont.Orientation:= 900;  // Bottom label angle
           if(Form1.tTime > (3600*Form1.tSec)) then
                DateTimeIntervalChartSource1.DateTimeFormat := 'h:nn:ss'
           else
                DateTimeIntervalChartSource1.DateTimeFormat := 'n:ss'
       end
    else
       begin
          Chart1.BottomAxis.Marks.Source:= nil;
          Chart1.BottomAxis.Marks.Style := TSeriesMarksStyle(smsNone);
          Chart1.BottomAxis.Marks.Format:= '%0:.9g';            // Bottom label format
          Chart1.BottomAxis.Marks.LabelFont.Orientation:= 0;    // Bottom label angle
       end;

end;

//*************************************************
// Form1 のStringGridの内容をChartに反映する。
//*************************************************
procedure TForm2.ChartSet;
begin
   //  Define Line Name . Please change to TP1,INP,OUT,Vcc etc
       Form2.CH1.Caption:=Form1.StringGrid1.Cells[1,1];
       Form2.CH2.Caption:=Form1.StringGrid1.Cells[1,2];
       Form2.CH3.Caption:=Form1.StringGrid1.Cells[1,3];
       Form2.CH4.Caption:=Form1.StringGrid1.Cells[1,4];
       Form2.CH5.Caption:=Form1.StringGrid1.Cells[1,5];
       Form2.CH6.Caption:=Form1.StringGrid1.Cells[1,6];
       Form2.CH7.Caption:=Form1.StringGrid1.Cells[1,7];
       Form2.CH8.Caption:=Form1.StringGrid1.Cells[1,8];

   //  Line Color setting
       Form2.ChColor[1]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,1]));
       Form2.ChColor[2]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,2]));
       Form2.ChColor[3]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,3]));
       Form2.ChColor[4]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,4]));
       Form2.ChColor[5]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,5]));
       Form2.ChColor[6]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,6]));
       Form2.ChColor[7]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,7]));
       Form2.ChColor[8]:=TColor(StrToInt('$'+Form1.StringGrid1.Cells[4,8]));

          Form2.LSeries[1].LinePen.Color:= Form2.chColor[1];
                        Form2.LCH1.Color:= Form2.chColor[1];
                        Form1.LCH1.Color:= Form2.chColor[1];
          Form2.LSeries[2].LinePen.Color:= Form2.chColor[2];
                        Form2.LCH2.Color:= Form2.chColor[2];
                        Form1.LCH2.Color:= Form2.chColor[2];
          Form2.LSeries[3].LinePen.Color:= Form2.chColor[3];
                        Form2.LCH3.Color:= Form2.chColor[3];
                        Form1.LCH3.Color:= Form2.chColor[3];
          Form2.LSeries[4].LinePen.Color:= Form2.chColor[4];
                        Form2.LCH4.Color:= Form2.chColor[4];
                        Form1.LCH4.Color:= Form2.chColor[4];
          Form2.LSeries[5].LinePen.Color:= Form2.chColor[5];
                        Form2.LCH5.Color:= Form2.chColor[5];
                        Form1.LCH5.Color:= Form2.chColor[5];
          Form2.LSeries[6].LinePen.Color:= Form2.chColor[6];
                        Form2.LCH6.Color:= Form2.chColor[6];
                        Form1.LCH6.Color:= Form2.chColor[6];
          Form2.LSeries[7].LinePen.Color:= Form2.chColor[7];
                        Form2.LCH7.Color:= Form2.chColor[7];
                        Form1.LCH7.Color:= Form2.chColor[7];
          Form2.LSeries[8].LinePen.Color:= Form2.chColor[8];
                        Form2.LCH8.Color:= Form2.chColor[8];
                        Form1.LCH8.Color:= Form2.chColor[8];


end;
//*************************************************
//
//*************************************************
procedure TForm2.ChartClear;
    var i:Integer;
begin
   for i:=1 to 8 do
     begin
       LSeries[i].Clear;
     end;
end;

//*************************************************
//
//*************************************************
procedure TForm2.CH1Change(Sender: TObject);
begin
  LSeries[1].Active:=CH1.Checked;
end;

procedure TForm2.CH2Change(Sender: TObject);
begin
  LSeries[2].Active:=CH2.Checked;
end;

procedure TForm2.CH3Change(Sender: TObject);
begin
    LSeries[3].Active:=CH3.Checked;
end;

procedure TForm2.CH4Change(Sender: TObject);
begin
    LSeries[4].Active:=CH4.Checked;
end;

procedure TForm2.CH5Change(Sender: TObject);
begin
    LSeries[5].Active:=CH5.Checked;
end;

procedure TForm2.CH6Change(Sender: TObject);
begin
    LSeries[6].Active:=CH6.Checked;
end;

procedure TForm2.CH7Change(Sender: TObject);
begin
    LSeries[7].Active:=CH7.Checked;
end;

procedure TForm2.CH8Change(Sender: TObject);
begin
    LSeries[8].Active:=CH8.Checked;
end;
//*************************************************
// Chart画面を閉じるときに LineSeriesを開放する。
//*************************************************
procedure TForm2.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var 
  i:Integer;
begin
    Chartclear;
    for i:=1 to 8 do
         begin
             LSeries[i].Free;
         end;
end;

//*************************************************
// 
//*************************************************
procedure TForm2.FormResize(Sender: TObject);
var
   i:Integer;
begin
   i:=Panel1.Height;
   i:=i div 10;
   CH1.Top:=i;
   LCH1.Top:=i+20;
   CH2.Top :=i*2;
   LCH2.Top:=i*2+20;
   CH3.Top :=i*3;
   LCH3.Top:=i*3+20;
   CH4.Top :=i*4;
   LCH4.Top:=i*4+20;
   CH5.Top :=i*5;
   LCH5.Top:=i*5+20;
   CH6.Top :=i*6;
   LCH6.Top:=i*6+20;
   CH7.Top :=i*7;
   LCH7.Top:=i*7+20;
   CH8.Top :=i*8;
   LCH8.Top:=i*8+20;
end;

end.
